import AvaLoginBlock from "./AvaLoginBlock";
import TimeOfCreation from "./TimeOfCreation";
import styled from "styled-components";
import {SpaceBetweenWrapper} from "../shared/styledComponents";

const AnswerWrap = styled.div`
  margin-left: 30px;
  margin-top: 3px;
  min-width: 100px;
  overflow: auto;
`

const CommentBlockStyled = styled.div`
  display: flex;
  flex-direction: column;
  min-width: 100px;
  overflow: auto;
  box-shadow: rgba(0, 0, 0, 0.05) 0px 1px 2px 0px;

`
const CommentText = styled.p`
  word-wrap: break-word;
  padding-right: 10px;
`

const Comment = ({commentData, closeModal}) => {
    return (
        <>
            <CommentBlockStyled>
                <SpaceBetweenWrapper>
                    <AvaLoginBlock user={commentData.owner} closeModal={closeModal}
                                   styled={{height: "30px"}}/>
                    <TimeOfCreation createdTime={commentData.createdAt}/>
                </SpaceBetweenWrapper>
                <CommentText>{commentData.text}</CommentText>

                {commentData.answers &&
                <AnswerWrap>
                    {commentData.answers.map((item, i) => <Comment commentData={item} key={i}/>)}
                </AnswerWrap>
                }
            </CommentBlockStyled>
        </>
    )
}

export default Comment;