import {connect} from "react-redux";
import {useEffect, useState} from "react";
import {gqlGetUserFollowers, gqlSubscribe, gqlUnSubscribe} from "../shared/services&utilits/gqlRequest";
import {
    setActiveUserData,
} from "../store/actionCreators/ActionCreators";


function SubscribeButton({followers, id, activeUser, setActiveUserData, ownerData}){
    const [isSabscribed, setIsSabscribed] = useState(isAlreadySubscribed())
    console.log(followers)
    useEffect(()=>{
        if (isAlreadySubscribed() && !isSabscribed){
            setIsSabscribed(true)
        }
        if (!isAlreadySubscribed() && isSabscribed){
            setIsSabscribed(false)
        }
    })

    function isAlreadySubscribed() {
        return followers && followers.find((follower)=>follower._id === id);
    }

    function clickHandler(){
        if (!isSabscribed){
            gqlSubscribe(id, activeUser._id, []).then((res)=> res.ok && updateUserFollowers())
        } else {
            gqlUnSubscribe(id, []).then((res)=> res.ok && updateUserFollowers())
        }
    }
    async function updateUserFollowers(){
        const a= await gqlGetUserFollowers(activeUser._id)
        const res = await a.json()
        if (res){
            activeUser.followers = await  res.data.UserFindOne.followers;
            console.log(activeUser)
            setActiveUserData(activeUser);
        }
    }

    return <button onClick={clickHandler}>{isSabscribed ? "unsabscribe" : "sabscribe"}</button>
}
const mapStateToProps = (state) => {
    return {
        id: state.auth.user.sub.id,
        ownerData: state.ownerData,
        activeUser: state.activeUser,
    }
}
const mapDispatchToProps = (dispatch) => {
    return {
        setActiveUserData: (user) => dispatch(setActiveUserData(user))
    }
}

export default connect(mapStateToProps, mapDispatchToProps)(SubscribeButton)